#######################################################################
#                                                                     #
#       (c) Copyright 2013                                            #
#       All rights reserved                                           #
#                                                                     #
#       Programs written by Ling Zhong                                #
#       Department of Computer Science                                #
#       New Jersey Institute of Technology                            #
#       University Heights, Newark, NJ 07102, USA                     #
#       In the group of Jason T. L. Wang (NJIT)                       #
#                                                                     #
#	 Permission to use, copy, modify, and distribute this	          #
#	 software and its documentation for any purpose and without       #
#	 fee is hereby granted, provided that this copyright	          #
#	 notice appears in all copies.   Programmer(s) makes no	          #
#	 representations about the suitability of this		              #
#	 software for any purpose.  It is provided "as is" without        #
#	 express or implied warranty.				                      #
#                                                                     #
#######################################################################

$species = $ARGV[0];
$fn = $ARGV[1];


for(my $i = 0; $i < $fn; $i++){
   for(my $j = 0; $j < 20; $j++){
	   system("libsvm-3.16/svm-predict ftable/ftable$i model/$species/r$j/model$i model/$species/r$j/out$i  > /dev/null");
       
	}
}

@rate = ();
open(RATE, "model/$species/rate");
while(<RATE>){
   chomp;
   #print $_."<br>";
   push @rate, $_;
}
close RATE;

@r = ();
for(my $j = 0; $j < 20; $j++){
   $p = 0;
   for(my $i = 0; $i < $fn; $i++){
      open(OUT, "model/$species/r$j/out$i");
	  while(<OUT>){
	     chomp;
		 #print RESULT $_."\n";
		 if($_ == 1){$p++;}
	  }
	  close OUT;
   }
   if ($p > ($fn / 2)){
      push @r, 1;
   }
   else{
      push @r, -1;
   }
}

$sum = 0;
for(my $j = 0; $j < 20; $j++){
  $sum = $sum + $r[$j] * $rate[$j];
  system("rm model/$species/r$j/out*");
}
$sum = sprintf "%.3f", $sum;
open(RESULT, ">result");
if($sum > 0){
    print RESULT "The input sequence is classified as a pre-miRNA.";
}
else{
    print RESULT "The input sequence is classified as a pseudo pre-miRNA.";
}
close RESULT;

open(H, ">h");
print H $sum;
close H;

system("rm outfeasvm");
system("rm *.ps");
#system("rm model/$species/r$j/out*");
system("rm ftable/*");


