#######################################################################
#                                                                     #
#       (c) Copyright 2013                                            #
#       All rights reserved                                           #
#                                                                     #
#       Programs written by Ling Zhong                                #
#       Department of Computer Science                                #
#       New Jersey Institute of Technology                            #
#       University Heights, Newark, NJ 07102, USA                     #
#       In the group of Jason T. L. Wang (NJIT)                       #
#                                                                     #
#	 Permission to use, copy, modify, and distribute this	          #
#	 software and its documentation for any purpose and without       #
#	 fee is hereby granted, provided that this copyright	          #
#	 notice appears in all copies.   Programmer(s) makes no	          #
#	 representations about the suitability of this		              #
#	 software for any purpose.  It is provided "as is" without        #
#	 express or implied warranty.				                      #
#                                                                     #
#######################################################################

$fealist = $ARGV[0];
$feasetn = $ARGV[1];
$species = $ARGV[2];

#create trainning file
open(TRAIN,"outfeasvm");
$row = 0;
while ( <TRAIN> )
{
  chomp;
  my @line = split / /;
  foreach my $column (@line)
  {
    push @{$fea[$row]}, $column;
  }
  $row++;
}
close TRAIN;

@fn=();
open(FEANO, "model/$species/f$fealist");
while ( <FEANO> )
{
  chomp;
  push (@fn, $_); 
}
close FEANO;
$nfn = $#fn;

open (FEATABLE, ">ftable/ftable$feasetn");
    
my $r = 0;
while($r < $row){
	print FEATABLE "$fea[$r][0] ";
	for(my $i = 0; $i <= $nfn; $i++){
	   $fn = $fn[$i];
	   my $s = $fea[$r][$fn];
	   my $l = length($s);
	   for(my $j = 0; $j < $l; $j++){
	       my $c = substr($s, $j, 1);
		   if($c eq ':'){
		       $v = substr($s, $j+1);
			   $v =~ s/\r|\n//g;
			   last;
		   }
	   }
	   $dd = $i + 1;
	   print FEATABLE "$dd:$v ";
	}
	print FEATABLE "\n";
	$r++;
}
close FEATABLET;



